//---------------------------------------------------------------------------
//
// Name:        VEDrawingFrm.h
// Author:      Tom Dlouh
// Created:     17.2.2009 17:13:29
// Description: VEDrawingFrm class declaration
//
//---------------------------------------------------------------------------

#ifndef __VEDRAWINGFRM_h__
#define __VEDRAWINGFRM_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/filedlg.h>
#include <wx/menu.h>
#include <wx/colordlg.h>
#include <wx/statusbr.h>
#include <wx/textctrl.h>
#include <wx/spinctrl.h>
#include <wx/tglbtn.h>
#include <wx/toolbar.h>
#include <wx/statbmp.h>
////Header Include End

////Dialog Style Start
#undef VEDrawingFrm_STYLE
#define VEDrawingFrm_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

#include "VEObjects.cpp"

class VEDrawingFrm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		VEDrawingFrm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("VEDrawing"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = VEDrawingFrm_STYLE);
		virtual ~VEDrawingFrm();
        static int select;		
		void WxToolButton4Click(wxCommandEvent& event);
		void CloseClick(wxCommandEvent& event);
		void CloseBtnClick(wxCommandEvent& event);
		void WxToolButton4Click1(wxCommandEvent& event);
		void WxToolButton2Click(wxCommandEvent& event);
		void SaveBtnClick(wxCommandEvent& event);
		void VEDrawingFrmActivate(wxActivateEvent& event);	
		void paint();
		void paint(bool repaint);        	
		void WxToolButton2Click1(wxCommandEvent& event);
		void WxToolButton5Click(wxCommandEvent& event);
		void VEDrawingFrmMouseMotion(wxMouseEvent& event);
		void WxToolButton6Click(wxCommandEvent& event);
		void WxToolButton7Click(wxCommandEvent& event);
		void WxToolButton8Click(wxCommandEvent& event);
		void WxToggleButton1Click(wxCommandEvent& event);
	    void Mnusave1007Click(wxCommandEvent& event);
	    void setBackgroundClick(wxCommandEvent& event);
	    void setForegroundClick(wxCommandEvent& event);
		void penWidthUpdated(wxSpinEvent& event );
		void WxToolButton5Click1(wxCommandEvent& event);
		void WxToolButton3Click(wxCommandEvent& event);
		void delBack();
		void setEditButtons();
		void WxToolButton6Click1(wxCommandEvent& event);
		void LineBtnClick(wxCommandEvent& event);
		void RoundBtnClick(wxCommandEvent& event);
    	void DotMenu(wxCommandEvent& event);
    	void Solid(wxCommandEvent& event);
    	void SolidMenu(wxCommandEvent& event);
    	void DotMenu1(wxCommandEvent& event);
   		void RoundSpinUpdated(wxSpinEvent& event );
    	void SDMenu(wxCommandEvent& event);
    	void DMenu(wxCommandEvent& event);
    	void LDMenu(wxCommandEvent& event);
    	void DDMenu(wxCommandEvent& event);
    	void STMenu(wxCommandEvent& event);
    	void CHMenu(wxCommandEvent& event);
    	void HHMenu(wxCommandEvent& event);
    	void VHMenu(wxCommandEvent& event);
		void WxToolButton1Click(wxCommandEvent& event);
	void ShowAbout(wxCommandEvent& event);
		void BgSolid(wxCommandEvent& event);
		void BgTrans(wxCommandEvent& event);
		void BgStip(wxCommandEvent& event);
		void BgCH(wxCommandEvent& event);
		void BgHH(wxCommandEvent& event);
		void BgVH(wxCommandEvent& event);
		void BGCOLUpdated(wxCommandEvent& event);

		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxFileDialog *svDialog;
		wxMenuBar *WxMenuBar1;
		wxColourDialog *dgBgcol;
		wxColourDialog *dgFgcol;
		wxStatusBar *SB;
		wxSpinCtrl *RoundSpin;
		wxTextCtrl *FGCOL;
		wxTextCtrl *BGCOL;
		wxSpinCtrl *penWidth;
		wxToggleButton *WxToggleButton1;
		wxToolBar *WxToolBar1;
		wxStaticBitmap *paintspace;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_MNU_FILE_1001 = 1001,
			ID_MNU_NEW_1006 = 1006,
			ID_MNU_SAVE_1007 = 1007,
			ID_MNU_EXIT_1008 = 1008,
			ID_MNU_EDIT_1083 = 1083,
			ID_MNU_BACK_1084 = 1084,
			ID_MNU_UNDO_1085 = 1085,
			ID_MNU_INSERT_1002 = 1002,
			ID_MNU_LINE_1016 = 1016,
			ID_MNU_RECTANGLE_1017 = 1017,
			ID_MNU_CIRCLE_1018 = 1018,
			ID_MNU_POLYLINE_1019 = 1019,
			ID_MNU_ROUNDRECTANGLE_1071 = 1071,
			ID_MNU_ELLIPSA_1072 = 1072,
			ID_MNU_EDIT_1003 = 1003,
			ID_MNU_COLORS_1009 = 1009,
			ID_MNU_SETFOREGROUND_1010 = 1010,
			ID_MNU_SETBACKGROUND_1011 = 1011,
			ID_MNU_FILL_1012 = 1012,
			ID_MNU_SOLID_1013 = 1013,
			ID_MNU_DOT_1062 = 1062,
			ID_MNU_SHORTDASH_1063 = 1063,
			ID_MNU_DASH_1064 = 1064,
			ID_MNU_LONGDASH_1065 = 1065,
			ID_MNU_DOTDASH_1066 = 1066,
			ID_MNU_STIPPLE_1067 = 1067,
			ID_MNU_CROSSHATCH_1068 = 1068,
			ID_MNU_HORIZONTALHATCH_1069 = 1069,
			ID_MNU_VERTICALHATCH_1070 = 1070,
			ID_MNU_OBJECTFILL_1076 = 1076,
			ID_MNU_SOLID_1077 = 1077,
			ID_MNU_TRANSPARENT_1078 = 1078,
			ID_MNU_STIPPLE_1079 = 1079,
			ID_MNU_CROSSHATCH_1080 = 1080,
			ID_MNU_HORIZONTALHATCH_1081 = 1081,
			ID_MNU_VERTICALHATCH_1082 = 1082,
			ID_MNU_HELP_1004 = 1004,
			ID_MNU_ABOUTVEDRAWING_1005 = 1005,
			
			ID_SB = 1041,
			ID_ROUNDSPIN = 1061,
			ID_WXSEPARATOR6 = 1060,
			ID_WXTOOLBUTTON5 = 1058,
			ID_BGCOL = 1057,
			ID_WXSEPARATOR5 = 1056,
			ID_WXTOOLBUTTON2 = 1053,
			ID_FGCOL = 1051,
			ID_WXSEPARATOR4 = 1048,
			ID_PENWIDTH = 1050,
			ID_WXTOGGLEBUTTON1 = 1047,
			ID_WXSEPARATOR3 = 1046,
			ID_POLYBTN = 1045,
			ID_CIRBTN = 1044,
			ID_ROUND = 1042,
			ID_RECTBTN = 1043,
			ID_LNBTN = 1040,
			ID_WXSEPARATOR2 = 1039,
			ID_BTNFORW = 1038,
			ID_BTNBACK = 1036,
			ID_WXSEPARATOR1 = 1033,
			ID_CLOSEBTN = 1032,
			ID_SAVEBTN = 1030,
			ID_WXTOOLBUTTON1 = 1029,
			ID_WXTOOLBAR1 = 1023,
			ID_SPACE = 1020,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
    	void addObj(Object * res);
		static int arrSize;
        static int itemsCount;
        static int backCount;
        static int selObj;
        static int lastSelObj;	
        bool nowDraw;	
        Object ** arrBack;
        Object ** arrObj;
        
        enum toolList { line = 0, rrect, rectangle, circle, polygon, selector, ellipse};
        enum toolList tool;
};

#endif
