#include <wx/wx.h>

#include <math.h>
using namespace std;

//Bod
class Point {
    public:
        int x,y;
        Point():x(0),y(0) {}
        Point(int _x, int _y): x(_x), y(_y) {}
        void paint () {}; 
};

//Zkladn tda celho projektu, vechny kreslc prvky jsou jejmy potomky
class Object {
    public:
        wxColour bgcol, fgcol;
        int width ,r;
        bool selBegin, selNext, middle;
        int style, bgstyle;
        
        Point startPoint, nextPoint;
        
        Object(): startPoint(), nextPoint() {
            selBegin = false;
            selNext = false;
            middle = false;
        };
        
        Object(Point _startPoint): startPoint(_startPoint), nextPoint() {
            selBegin = false;
            selNext = false;
            middle = false;
        };
        
        //Volba vpln
        int ReturnStyle(int id) {
            if (id == 0) return wxSOLID;
            else if (id == 1) return wxTRANSPARENT ;
            else if (id == 2) return wxDOT;
            else if (id == 3) return wxLONG_DASH;
            else if (id == 4) return wxSHORT_DASH;
            else if (id == 5) return wxDOT_DASH;
            else if (id == 6) return wxSTIPPLE;
            else if (id == 7) return wxCROSS_HATCH ;
            else if (id == 8) return wxHORIZONTAL_HATCH;
            else if (id == 9) return wxVERTICAL_HATCH;
            else return wxSOLID;
        }
        
        virtual ~Object() {};
        
        virtual void paint (wxMemoryDC & dc, int select) {};
        
        //Nastaven paramentr objektu
        void setParams(int _width, wxColour _bgcol, wxColour _fgcol) {
            width = _width;
            bgcol = _bgcol;
            fgcol = _fgcol;    
        };
        
        //Nastaven stylu pera
        void setFill (int a) {
            style=ReturnStyle(a);
        };
        
        //Nastaven vpln objektu
        void setBgFill (int a) {
            bgstyle=ReturnStyle(a);  
        };
        
        //Nastavit barvu pozad
        void setBg(wxColour _bgcol) {
            bgcol = _bgcol;
        };
        
        // Nastavit barvu poped
        void setFg(wxColour _fgcol) {
            fgcol = _fgcol;
        };
        
        //Nastavit ku pera
        void setWidth(int _width) {
            width = _width;
        };
        
        //nastaven parametr kreslen
        void setPaint(wxMemoryDC & dc) {
            dc.SetBrush(wxBrush(bgcol, bgstyle));
            dc.SetPen(wxPen(fgcol, width, style));
        };
        
        //nastaven kulatostu roh (u Round Rectangle)
        void setRound(int _r) {
            r = _r;
        };
                
        //nastaven dalho bodu
        virtual void setPoint(Point point) {
            nextPoint = point;
        };
        
                
        bool isPoint(Point point) {
            int px = nextPoint.x/2 + startPoint.x/2 ;
            int py = nextPoint.y/2 + startPoint.y/2 ;
            if ((px - 3 < point.x) && (point.x < px + 3) && (py +3 > point.y) && (point.y > py-3)) {
                middle = true;
            } else {
                middle = false;
            }
            
            if(( startPoint.x - 3 < point.x ) && ( point.x  < startPoint.x +3) && (startPoint.y +3 > point.y ) && (point.y  > startPoint.y - 3 ) ) {
                selBegin = true;
            } else {
                selBegin = false;
            }
            if(( nextPoint.x - 3 < point.x ) && ( point.x  < nextPoint.x +3) && (nextPoint.y +3 > point.y ) && (point.y  > nextPoint.y - 3 ) ) {
                selNext = true;
            } else {
                selNext = false;
            }
            
            return (middle || selNext || selBegin);
        };
        
        //prava objektu pi editaci
        void setUpdatePoint(Point point) {
            if(selBegin == true) {
                startPoint = point;
            } else if (middle == true) {
                int px = nextPoint.x/2 + startPoint.x/2 ;
                int py = nextPoint.y/2 + startPoint.y/2 ;

               startPoint.x = startPoint.x  - (px - point.x);
               startPoint.y = startPoint.y  - (py - point.y);
               nextPoint.x = nextPoint.x - (px - point.x);
               nextPoint.y = nextPoint.y  - (py - point.y);

            } else if (selNext == true) {
                nextPoint = point;
            }             
        };
        
      //Zobrazen editanch bod
      void showAnchors(wxMemoryDC& dc,int select) {
            if (select == 1) {
                if( selBegin == true ) {
                    dc.SetBrush(wxColour(0,128,0));
                    dc.SetPen(wxPen(wxColour(0,128,0), 1, wxSOLID));
                } else {
                    dc.SetBrush(wxColour(0,128,0));
                    dc.SetPen(wxPen(wxColour(0,128,0), 1, wxSOLID));
                }
                dc.DrawRectangle(startPoint.x-2, startPoint.y-2,5,5);
                if( selNext == true ) {
                    dc.SetBrush(wxColour(0,128,0));
                    dc.SetPen(wxPen(wxColour(0,128,0), 1, wxSOLID));
                } else {
                    dc.SetBrush(wxColour(0,128,0));
                    dc.SetPen(wxPen(wxColour(0,128,0), 1, wxSOLID));
                }
                dc.DrawRectangle(nextPoint.x-2, nextPoint.y-2,5,5);

                if( middle == true ) {
                    dc.SetBrush(wxColour(0,128,0));
                    dc.SetPen(wxPen(wxColour(0,128,0), 1, style));
                } else {
                    dc.SetBrush(wxColour(0,128,0));
                    dc.SetPen(wxPen(wxColour(0,128,0), 1, style));
                }
                dc.DrawRectangle(nextPoint.x/2 + startPoint.x/2-2, nextPoint.y/2 + startPoint.y/2-2,5,5);
                setPaint(dc);
            };
        }        
};

//Elipsa
class Ellip : public Object {
    public:
        Ellip():Object() {};
        Ellip(Point _startPoint):Object(_startPoint) {};

        virtual void paint (wxMemoryDC & dc, int select) {
            int x,y,w,h;

            if(startPoint.x < nextPoint.x) {
                x=startPoint.x;
                w=nextPoint.x-startPoint.x;
            } else {
                x=nextPoint.x;
                w=startPoint.x-nextPoint.x;
            }

            if(startPoint.y < nextPoint.y) {
                y=startPoint.y;
                h=nextPoint.y-startPoint.y;
            } else {
                y=nextPoint.y;
                h=startPoint.y-nextPoint.y;
            }
            setPaint(dc);
            dc.DrawEllipse(x,y,w,h);
            showAnchors(dc, select);
        };
};

//Obdlnk
class Rect : public Object {
    public:
        Rect():Object() {};
        Rect(Point _startPoint):Object(_startPoint) {};
        
        virtual void paint (wxMemoryDC & dc, int select) {
            int x,y,w,h;
            
            if(startPoint.x < nextPoint.x) {
                x=startPoint.x;
                w=nextPoint.x-startPoint.x;
            } else {
                x=nextPoint.x;
                w=startPoint.x-nextPoint.x;
            }
            
            if(startPoint.y < nextPoint.y) {
                y=startPoint.y;
                h=nextPoint.y-startPoint.y;
            } else {
                y=nextPoint.y;
                h=startPoint.y-nextPoint.y;
            }
            setPaint(dc);
            dc.DrawRectangle(x,y,w,h);
            showAnchors(dc, select);
        };
};

//Obdlnk s kulatmy rohy
class RRect : public Object {
    public:
        RRect():Object() {};
        RRect(Point _startPoint):Object(_startPoint) {};

        virtual void paint (wxMemoryDC & dc, int select) {
            int x,y,w,h;

            if(startPoint.x < nextPoint.x) {
                x=startPoint.x;
                w=nextPoint.x-startPoint.x;
            } else {
                x=nextPoint.x;
                w=startPoint.x-nextPoint.x;
            }

            if(startPoint.y < nextPoint.y) {
                y=startPoint.y;
                h=nextPoint.y-startPoint.y;
            } else {
                y=nextPoint.y;
                h=startPoint.y-nextPoint.y;
            }
            setPaint(dc);
            dc.DrawRoundedRectangle(x,y,w,h,r);
            showAnchors(dc, select);
        };
};

//Kruh
class Circle : public Object {
    private:
        int radius;
    public:
        Circle(): Object(), radius(0) {};
        Circle(Point _startPoint): Object(_startPoint), radius(0) {}; 
        
        virtual void paint (wxMemoryDC & dc, int select) {
            int w,h;
            if(startPoint.x < nextPoint.x) {
                w = nextPoint.x - startPoint.x;
            } else {
                w = startPoint.x - nextPoint.x;
            }
            if(startPoint.y < nextPoint.y) {
                h = nextPoint.y - startPoint.y;
            } else {
                h = startPoint.y - nextPoint.y;
            }            
            
            radius = (int) sqrt (h*h + w*w);
            
            setPaint(dc);
            dc.DrawCircle(startPoint.x, startPoint.y, radius);
            showAnchors(dc, select);
        };       
};

//ra sloen z jednotlivch bod
class Poly : public Object {
    private: 
        int pointsCount;
        int listSize;
        Point * listPoints;
    public:
        Poly():Object(),pointsCount(0),listSize(10){
            listPoints = new Point[listSize];
        };
        Poly(Point _startPoint): Object(_startPoint),pointsCount(0),listSize(10) { 
            listPoints = new Point[listSize];
        };
    
        virtual void setPoint(Point point) {
            if(listSize == 1 + pointsCount) {
                listSize *= 2; 
                Point * mat = new Point [ listSize ];
                for ( int i = 0; i < pointsCount; i ++ ) {
                    mat[i] = listPoints[i];
                }
                listPoints = mat;   
            }
            
            listPoints[pointsCount] = point;
            pointsCount ++;
        };
    
        virtual void paint (wxMemoryDC& dc, int select) {
            setPaint(dc);
            dc.DrawLine(startPoint.x, startPoint.y, listPoints[0].x, listPoints[0].y);
            
            for(int i = 1; i < pointsCount ; i ++ ) {
                dc.DrawLine(listPoints[i-1].x, listPoints[i-1].y, listPoints[i].x, listPoints[i].y);
                 showAnchors(dc, select);
            }
            
        };
};

//ra
class Line : public Object {
    public:
        Line():Object() {};
        Line(Point _startPoint):Object(_startPoint) {};

        virtual void paint (wxMemoryDC & dc, int select) {
            setPaint(dc);
            dc.DrawLine(startPoint.x, startPoint.y, nextPoint.x, nextPoint.y);
            showAnchors(dc, select);
        };
};
